#pragma once
#include <coff/archive.hpp>
#include <coff/image.hpp>
#include <llodctor/llodctor_base.hpp>

namespace llo::s1
{
    class dctor_coff_t : public dctor_base_t
    {
        friend class dctor_lib_t;
      protected:
        const coff::image_t *img_header;
        const std::uint32_t num_sections;

      public:
        explicit dctor_coff_t( const std::vector< std::uint8_t > &image,
                               llo::s1::symbol_loader_base_t *symbol_loader = nullptr )
            : dctor_base_t( image, symbol_loader ), img_header( ( coff::image_t * )img.data() ),
              num_sections( img_header->file_header.num_sections )
        {
        }

        void generate( lloiff_t &iff ) override;
    };
} // namespace llo::s1