#pragma once
#include <llodctor/llodctor_coff.hpp>

namespace llo::s1
{
    class dctor_lib_t : public dctor_base_t
    {
        std::vector< std::pair< std::string, std::shared_ptr< llo::s1::dctor_coff_t > > > coff_dctors;

      public:
        explicit dctor_lib_t( const std::vector< std::uint8_t > &image,
                              llo::s1::symbol_loader_base_t *symbol_loader = nullptr )
            : dctor_base_t( image, symbol_loader )
        {
            ar::view lib( image.data(), image.size() );
            std::for_each( lib.begin(), lib.end(), [ & ]( const auto obj_meta ) {
                const auto [ obj_name, obj_entry ] = obj_meta;
                std::vector obj_data( obj_entry.begin(), obj_entry.end() );
                coff_dctors.push_back( { std::string( obj_entry.to_string( lib.string_table ) ),
                                         std::make_shared< llo::s1::dctor_coff_t >( obj_data ) } );
            } );
        }
        void generate( lloiff_t &iff ) override;
    };
} // namespace llo::s1